import React, { Component } from 'react'
import { FusePageSimple, DemoContent } from '@fuse'
import ReactTable from 'react-table'
import { withRouter } from 'react-router-dom'

import { FontAwesomeIcon } from '@fortawesome/react-fontawesome'
import {
  faTwitter,
  faFacebook,
  faLinkedin,
} from '@fortawesome/free-brands-svg-icons'

import {
  withStyles,
  Button,
  Divider,
  Typography,
  InputAdornment,
  Icon,
  Tooltip,
  Chip,
} from '@material-ui/core'
import { connect } from 'react-redux'
import { bindActionCreators } from 'redux'
import New{{name|capitalize}} from './crud/new'

import * as {{name}}Actions from './store/actions/{{name}}.actions'

const styles = theme => ({
  layoutRoot: {
    minHeight: '96vh',
  },
  button: {
    margin: theme.spacing.unit,
  },
  error: {
    background: theme.palette.error.dark,
  },
  toe: {
    overflow: 'hidden',
    textOverflow: 'ellipsis',
  },
  title: {
    textAlign: 'center',
    fontWeight: '700',
    width: '100%',
  },
})

class {{name|capitalize}} extends Component {
  constructor(props) {
    super(props)
    this.state = {
      open: false,
    }
  }

  handleClickOpen = () => {
    this.setState({ open: true })
  }

  handleClose = () => {
    this.setState({ open: false })
  }

  componentDidMount() {
    this.props.get{{name|capitalize}}s()
    // debugger
  }
  render() {
    const { classes } = this.props
    const data = []
    let that = this
    return (
      <FusePageSimple
        {%raw%}classes={{
          root: classes.layoutRoot,
        }}{%endraw%}
        header={
          <div className="p-24">
            <h2>{{name|capitalize}} Management</h2>
          </div>
        }
        contentToolbar={
          <div className="px-24">
            <div>
              <Button
                variant="contained"
                color="primary"
                onClick={this.handleClickOpen}
                className={classes.button}
              >
                Add new {{name|capitalize}}
              </Button>
            </div>
          </div>
        }
        content={
          <div className="p-24">
            <ReactTable
              data={this.props.{{name}}.{{name}}}
              columns={[
                {
                  Header: 'id',
                  accessor: 'id',
                  maxWidth: 50,
                },
                {% for attr in attributes -%}
                {
                  Header: '{{attr.name|capitalize}}',
                  accessor: '{{attr.name}}',
                  Cell: props => (
                    <div
                      className={classes.{{attr.name}}}
                      dangerouslySetInnerHTML={% raw %}{{ __html: props.value }}{%endraw%}
                    />
                  ),
                },
                {%endfor%}
                {
                  Header: 'Operations',
                  maxWidth: 250,
                  accessor: 'edit',
                  Cell: props => (
                    <div>
                      <Button
                        variant="contained"
                        color="error"
                        className={classes.button}
                      >
                        edit
                      </Button>
                      <Button
                        variant="contained"
                        color="error"
                        className={classes.error}
                      >
                        Delete
                      </Button>
                    </div>
                  ),
                },
              ]}
              defaultPageSize={10}
              className="-striped -highlight"
            />
            <New{{name|capitalize}}
              open={this.state.open}
              handleClose={e => this.handleClose()}
              save{{name|capitalize}}={e => this.save{{name|capitalize}}(e)}
            />
          </div>
        }
      />
    )
  }

  save{{name|capitalize}}({{name}}) {
      this.props.create{{name|capitalize}}({{name}})
      this.handleClose();
  }
}

function mapDispatchToProps(dispatch) {
  return bindActionCreators(
    {
      get{{name|capitalize}}s: {{name}}Actions.get{{name|capitalize}}s,
      create{{name|capitalize}}: {{name}}Actions.create{{name|capitalize}}
    },
    dispatch
  )
}

function mapStateToProps({{name}}) {
  return 
    {{name}}s: {{name}}.{{name}}s
  }
}
export default withStyles(styles, { withTheme: true })(
  connect(
    mapStateToProps,
    mapDispatchToProps
  )({{name|capitalize}})
)
